using Insight.Infrastructure;
using Insight.Infrastructure.Entities;
using Insight.Web.Constants;
using Microsoft.AspNetCore.Components;
using MongoDB.Driver;
using MudBlazor;

namespace Insight.Web.Pages.Management.Hosts;

public partial class HostCreateDialog
{
    [Parameter] public EventCallback OnChanges { get; set; }

    [Inject] private IMongoDatabase Database { get; init; } = default!;
    [Inject] private ISnackbar Snackbar { get; init; } = default!;
    [Inject] private ILogger<HostCreateDialog> Logger { get; init; } = default!;

    private HostEntity? Host { get; set; } = new();

    private async Task SubmitAsync()
    {
        if (Host is null) return;
        Host.Insert = DateTime.Now;

        try
        {
            await Database.Host()
                .InsertOneAsync(new HostEntity
                {
                    Insert = DateTime.Now,
                    Name = Host?.Name,
                    Description = Host?.Description,
                }, cancellationToken: default)
                .ConfigureAwait(false);

            Notification.Success(Snackbar);

            if (OnChanges.HasDelegate)
            {
                await InvokeAsync(async () =>
                {
                    await OnChanges.InvokeAsync(this);
                });
            }
        }
        catch (Exception ex)
        {
            Notification.Error(Snackbar);
            Logger.LogError(ex.ToString());
        }
        finally
        {
            Host = new();
            _visible = false;
        }
    }
}